org.freedesktop.ModemManager1.Modem.Signal: ModemManager Reference Manual

## org.freedesktop.ModemManager1.Modem.Signal org.freedesktop.ModemManager1.Modem.Signal — The ModemManager Signal interface. |

## Methods

    Setup           (IN  u     rate);
    SetupThresholds (IN  a{sv} settings);

## Properties

    Rate                readable   u
    RssiThreshold       readable   u
    ErrorRateThreshold  readable   b
    Cdma                readable   a{sv}
    Evdo                readable   a{sv}
    Gsm                 readable   a{sv}
    Umts                readable   a{sv}
    Lte                 readable   a{sv}
    Nr5g                readable   a{sv}

## Description

This interface provides access to extended signal quality information.

This interface will only be functional once the modem is ready to be registered in the cellular network. 3GPP devices will require a valid unlocked SIM card before any of the features in the interface can be used.

There are two different ways defined to use the interface: either enabling periodic polling (with the `Setup()` method), or configuring the device with thresholds so that it reports the value updates automatically (with the `SetupThresholds()` method, since 1.20).

Both `Setup()` and `SetupThresholds()` can also be used at the same time if required, e.g. if they report different signal quality measurement types.

The thresholds and polling setup will only be in effect if the modem is in enabled state. Changing the settings with `Setup()` or `SetupThresholds()` is also possible while in disabled state, though.

## Method Details

### The `Setup()` method

    Setup (IN  u rate);

Enable or disable the extended signal quality information retrieval via periodic polling.

Polling is less than optimal; a better way to be notified of extended signal quality updates is to configure the modem to trigger the reports when the signal changes, i.e. with `SetupThresholds()`.

Since: 1.2

`IN u `rate``: | refresh rate to set, in seconds. Use 0 to disable periodic polling.

### The `SetupThresholds()` method

    SetupThresholds (IN  a{sv} settings);

Setup thresholds so that the device itself decides when to report the extended signal quality information updates.

The thresholds configured via this method specify the delta between specific signal quality measurements that would trigger a report by the modem. For example, the user may want to be notified every time the signal RSSI changes more than 10dBm, so a value of 10 would be configured as `"rssi-threshold"`.

The device may not support this kind of threshold setting, and instead support fixed signal levels as thresholds (e.g. trigger reports when signal RSSI crosses -90dBm). On these devices, the threshold configured by the user as a difference between measurements is converted to fixed signal levels automatically, depending on the expected range for each of the configured values. E.g. if the user configures 10dBm as `"rssi-threshold"`, the fixed signal levels could be automatically set to -100dBm, -90dBm, -80dBm, -70dBm and -60dBm.

`"rssi-threshold"` | The difference of signal RSSI measurements, in dBm, that should trigger a signal quality report update, given as an unsigned integer (signature `"u"`). Use 0 to disable this threshold.
`"error-rate-threshold"` | A boolean value, indicating whether signal quality report updates should be triggered when error rate measurements change (signature `"b"`).

If any of the settings is not given as input, the corresponding threshold will be considered disabled, and device defaults will apply.

Since: 1.20

`IN a{sv} `settings``: | threshold values to set.

## Property Details

### The "Rate" property

    Rate  readable   u

Refresh rate, in seconds, for the extended signal quality information periodic polling, as configured via the `Setup()` method.

A value of 0 indicates the periodic polling is disabled.

Since: 1.2

### The "RssiThreshold" property

    RssiThreshold  readable   u

The difference of signal RSSI measurements, in dBm, that should trigger a signal quality report update.

A value of 0 indicates the threshold is disabled.

Since: 1.20

### The "ErrorRateThreshold" property

    ErrorRateThreshold  readable   b

Flag indicating whether signal quality report updates should be triggered on error rate measurement changes.

Since: 1.20

### The "Cdma" property

    Cdma  readable   a{sv}

Dictionary of available signal information for the CDMA1x access technology.

This dictionary is composed of a string key, with an associated data which contains type-specific information.

`"rssi"` | The CDMA1x RSSI (Received Signal Strength Indication), in dBm, given as a floating point value (signature `"d"`).
`"ecio"` | The CDMA1x Ec/Io, in dBm, given as a floating point value (signature `"d"`).
`"error-rate"` | Frame error rate, in percentage value, given as a floating point value (signature `"d"`). Since: 1.20.

Since: 1.2

### The "Evdo" property

    Evdo  readable   a{sv}

Dictionary of available signal information for the CDMA EV-DO access technology.

This dictionary is composed of a string key, with an associated data which contains type-specific information.

`"rssi"` | The CDMA EV-DO RSSI (Received Signal Strength Indication), in dBm, given as a floating point value (signature `"d"`).
`"ecio"` | The CDMA EV-DO Ec/Io, in dBm, given as a floating point value (signature `"d"`).
`"sinr"` | CDMA EV-DO SINR level, in dB, given as a floating point value (signature `"d"`).
`"io"` | The CDMA EV-DO Io, in dBm, given as a floating point value (signature `"d"`).
`"error-rate"` | Packet error rate, in percentage value, given as a floating point value (signature `"d"`). Since: 1.20.

Since: 1.2

### The "Gsm" property

    Gsm  readable   a{sv}

Dictionary of available signal information for the GSM/GPRS access technology.

This dictionary is composed of a string key, with an associated data which contains type-specific information.

`"rssi"` | The GSM RSSI (Received Signal Strength Indication), in dBm, given as a floating point value (signature `"d"`).
`"error-rate"` | Bit error rate (BER), in percentage value, given as a floating point value (signature `"d"`). Since: 1.20.

Since: 1.2

### The "Umts" property

    Umts  readable   a{sv}

Dictionary of available signal information for the UMTS (WCDMA) access technology.

This dictionary is composed of a string key, with an associated data which contains type-specific information.

`"rssi"` | The UMTS RSSI (Received Signal Strength Indication), in dBm, given as a floating point value (signature `"d"`).
`"rscp"` | The UMTS RSCP (Received Signal Code Power), in dBm, given as a floating point value (signature `"d"`).
`"ecio"` | The UMTS Ec/Io, in dB, given as a floating point value (signature `"d"`).
`"error-rate"` | Block error rate (BLER), in percentage value, given as a floating point value (signature `"d"`). Since: 1.20.

Since: 1.2

### The "Lte" property

    Lte  readable   a{sv}

Dictionary of available signal information for the LTE access technology.

This dictionary is composed of a string key, with an associated data which contains type-specific information.

`"rssi"` | The LTE RSSI (Received Signal Strength Indication), in dBm, given as a floating point value (signature `"d"`).
`"rsrq"` | The LTE RSRQ (Reference Signal Received Quality), in dB, given as a floating point value (signature `"d"`).
`"rsrp"` | The LTE RSRP (Reference Signal Received Power), in dBm, given as a floating point value (signature `"d"`).
`"snr"` | The LTE S/R ratio, in dB, given as a floating point value (signature `"d"`).
`"error-rate"` | Block error rate (BLER), in percentage value, given as a floating point value (signature `"d"`). Since: 1.20.

Since: 1.2

### The "Nr5g" property

    Nr5g  readable   a{sv}

Dictionary of available signal information for the 5G access technology.

This dictionary is composed of a string key, with an associated data which contains type-specific information.

`"rsrq"` | The 5G RSRQ (Reference Signal Received Quality), in dB, given as a floating point value (signature `"d"`).
`"rsrp"` | The 5G RSRP (Reference Signal Received Power), in dBm, given as a floating point value (signature `"d"`).
`"snr"` | The 5G S/R ratio, in dB, given as a floating point value (signature `"d"`).
`"error-rate"` | Block error rate (BLER), in percentage value, given as a floating point value (signature `"d"`). Since: 1.20.

Since: 1.16